//
//  MTLLoader.h
//  Lesson37_OSXCocoa
//
//  Created by Will Thimbleby on Tue Sep 02 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#include <OpenGL/gl.h>
#include <OpenGL/glu.h>

typedef struct
{
	float		r, g, b;
}MTLColor;

typedef enum
{
	MTLLight_none = 0,
	MTLLight_ambientDiffuse = 1,
	MTLLight_all = 2
}MTLLight;

typedef struct
{
	NSString		*name;
	MTLColor		ambientColor, diffuseColor, specularColor;
	
	MTLLight		lightingStyle;
	
	float			shininess;
	
	GLuint			textureMap;
}MTLMaterial;


@interface MTLLoader : NSObject
{
	MTLMaterial		materials[10];
	int				materialCount;
}

- (MTLMaterial*) getMaterial:(NSString*)name;
@end

GLuint GetOpenGLTextureFromPath(NSString *path);
