//
//  NTBox.m
//  NewtonTest
//
//  Created by William Thimbleby on Sat Mar 05 2005.
//  Copyright (c) 2005 __MyCompanyName__. All rights reserved.
//

#import "NTBox.h"
#import "MTLLoader.h"
#import "OBJModel.h"
#import <OpenGL/gl.h>
#import <GLUT/glut.h>

OBJModel *boxModel = nil;
GLuint woodTex = 0;

@implementation NTBox

- (id)init
{
	self = [super init];
	
	if(!boxModel)
		boxModel = [[OBJModel alloc] initWithFile:[NSString stringWithFormat:@"%@/cube.obj", [[NSBundle mainBundle] resourcePath]]];
	if(woodTex == 0)
		woodTex = GetOpenGLTextureFromPath([NSString stringWithFormat:@"%@/wood.png", [[NSBundle mainBundle] resourcePath]]);
	

	return self;
}

- (void)setMatrix:(const float*) mat
{
	memcpy(matrix, mat, 16*sizeof(float));
	
	//NSLog(@"{%f,%f,%f,%f\n%f,%f,%f,%f\n%f,%f,%f,%f\n%f,%f,%f,%f}",mat[0],mat[1],mat[2],mat[3],mat[4],mat[5],mat[6],mat[7],mat[8],mat[9],mat[10],mat[11],mat[12],mat[13],mat[14],mat[15]);
}

- (void)drawShadow
{
	glPushMatrix();
	glMultMatrixf (matrix);	
	
	glScalef(0.25,0.25,0.25);

	[boxModel castShadow];
	glPopMatrix();
}

- (void)draw
{
	glPushMatrix();
	glMultMatrixf (matrix);
	glScalef(0.25,0.25,0.25);
	
	//[boxModel render];
	
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, woodTex);
	
	glBegin(GL_QUADS);
	// front
	glNormal3f(0.0, 0.0, 1.0);
	glTexCoord2f(0.0, 0.0); glVertex3f(-1, -1, 1);
	glTexCoord2f(1.0, 0.0); glVertex3f( 1, -1, 1);
	glTexCoord2f(1.0, 1.0); glVertex3f( 1,  1, 1);
	glTexCoord2f(0.0, 1.0); glVertex3f(-1,  1, 1);
	
	// back
	glNormal3f(0.0, 0.0, -1.0);
	glTexCoord2f(0.0, 0.0); glVertex3f( 1, -1, -1);
	glTexCoord2f(1.0, 0.0); glVertex3f(-1, -1, -1);
	glTexCoord2f(1.0, 1.0); glVertex3f(-1,  1, -1);
	glTexCoord2f(0.0, 1.0); glVertex3f( 1,  1, -1);
	
	// top
	glNormal3f(0.0, 1.0, 0.0);
	glTexCoord2f(0.0, 0.0); glVertex3f(-1,  1,  1);
	glTexCoord2f(1.0, 0.0); glVertex3f( 1,  1,  1);
	glTexCoord2f(1.0, 1.0); glVertex3f( 1,  1, -1);
	glTexCoord2f(0.0, 1.0); glVertex3f(-1,  1, -1);
	
	// bottom
	glNormal3f(0.0, -1.0, 0.0);
	glTexCoord2f(0.0, 0.0); glVertex3f(-1, -1, -1);
	glTexCoord2f(1.0, 0.0); glVertex3f( 1, -1, -1);
	glTexCoord2f(1.0, 1.0); glVertex3f( 1, -1,  1);
	glTexCoord2f(0.0, 1.0); glVertex3f(-1, -1,  1);
	
	// left
	glNormal3f(-1.0, 0.0, 0.0);
	glTexCoord2f(0.0, 0.0); glVertex3f(-1, -1, -1);
	glTexCoord2f(1.0, 0.0); glVertex3f(-1, -1,  1);
	glTexCoord2f(1.0, 1.0); glVertex3f(-1,  1,  1);
	glTexCoord2f(0.0, 1.0); glVertex3f(-1,  1, -1);
	
	// right
	glNormal3f(1.0, 0.0, 0.0);
	glTexCoord2f(0.0, 0.0); glVertex3f(1,  -1,  1);
	glTexCoord2f(1.0, 0.0); glVertex3f(1,  -1, -1);
	glTexCoord2f(1.0, 1.0); glVertex3f(1,   1, -1);
	glTexCoord2f(0.0, 1.0); glVertex3f(1,   1,  1);
	
	glEnd();
	
	glDisable(GL_TEXTURE_2D);
	
	glPopMatrix();
}

@end
